{$I-}
program BinToHex;

uses Crt;

var
  BinFile: File;
  HexFile: Text;
  AlkuAddr, Addr: Word;
  Ix, Luettu, ApuI: Integer;
  BJono: array[0..15] of Byte;
  ApuS: String;
  ChkSum: Byte;

const
  NibToHex: array[0..15] of Char = '0123456789ABCDEF';

type
  String4 = String[4];

procedure ByteToHex(Tavu: Byte);
begin
  Inc(ChkSum, Tavu);    { pivitetn tark.summaa }
  ApuS[Ix] := NibToHex[(Tavu shr 4) and 15];
  Inc(Ix);
  ApuS[Ix] := NibToHex[Tavu and 15];
  Inc(Ix);
end;

function WordToHex(W: Word): String4;
begin
  WordToHex :=
    NibToHex[(Hi(W) shr 4) and 15]
  + NibToHex[Hi(W) and 15]
  + NibToHex[(Lo(W) shr 4) and 15]
  + NibToHex[Lo(W) and 15];
end;

function HexToWord(var S: String; var W: Word): Boolean;
var
  I: Integer;
  B: Byte;
begin
  W := 0;
  HexToWord := False;
  if Length(S) in [1..4] then
  begin
    for I := 1 to Length(S) do
    begin
      if S[I] in ['0'..'9'] then B := Ord(S[I]) and 15
      else if S[I] in ['A'..'F', 'a'..'f'] then B := (Ord(S[I]) and 7) + 9
      else Exit;
      W := (W shl 4) + B;
    end;
    HexToWord := True;
  end;
end;

function OnxK: Boolean;
begin
  Write('Tyhotaanko ' + ParamStr(2) + '? K/E');
  OnxK := UpCase(ReadKey) = 'K';
  Write(#13);
  Close(HexFile);
end;


begin
  if ParamCount < 2 then
  begin
    Writeln('Parametrit puuttuu, kyt nin:');
    Writeln('Bintohex binfile hexfile.hex [start_hex_addr]');
    Exit;
  end;
  ApuS := ParamStr(3);
  if not HexToWord(ApuS, AlkuAddr) then AlkuAddr := 0;
  Addr := AlkuAddr;
  Assign(BinFile, ParamStr(1));
  Reset(BinFile, 1);
  if IOResult = 0 then
  begin
    Assign(HexFile, ParamStr(2));
    Reset(HexFile);
    if (IOResult <> 0) or OnxK then
    begin
      Rewrite(HexFile);
      if IOResult = 0 then
      begin
        repeat
          BlockRead(BinFile, BJono, 16, Luettu);
          if Luettu > 0  then
          begin
            ApuS[1] := ':';
            Ix := 2;
            ChkSum := 0;
            ByteToHex(Luettu);
            ByteToHex(Hi(Addr));
            ByteToHex(Lo(Addr));
            ByteToHex(0);
            for ApuI := 0 to Luettu - 1 do ByteToHex(BJono[ApuI]);
            ByteToHex(-ChkSum);
            ApuS[0] := Chr(Ix - 1);  { jonon pituus }
            Writeln(HexFile, ApuS);
            Inc(Addr, Luettu);
          end;
        until (IOResult <> 0) or (Luettu < 16);
        Writeln(HexFile, ':00000001FF');
        { lopputeksti nytlle}
        Writeln(ParamStr(1) + ' -> ' + ParamStr(2) + ' ['
          + WordToHex(AlkuAddr) + '-' + WordToHex(Addr) + ']');
      end;
      Close(HexFile);
    end;
  end;
  Close(BinFile);
end.